Bug 58812 - usb modem drops \n characters when is used as a tty character terminal
usb modem drops \n characters when is used as a tty character terminal
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
6.2
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-01-24 18:20 EST by Vladimir Razgulin
Modified: 2008-08-01 12:22 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:39:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Vladimir Razgulin 2002-01-24 18:20:13 EST
From Bugzilla Helper:
User-Agent: Mozilla/4.51 [en] (WinNT; I)

Description of problem:
We  use a  usb  modem as  a  tty character  device  with N_TTY  line
discipline.  For that terminal ONLCR flag is on, so opost() function
from n_tty.c tries to output \n character as a pair \r + \n.
 
To do  that it calls  tty->driver.put_char(tty, c) which  points to 
acm_tty_write() two times, once for each character.                 
 
First call  for \r  goes through  fine, but the  second call  for \n
returns  0  because  of  acm->writeurb.status  ==  -EINPROGRESS  and
doesn't send that \n character.
 
opost() function  doesn't check a return value from put_char(), doesn't
detect dropped characters, and always returns 0 (OK).
write_chan() gets that OK from opost() and doesn't know that it needs to
re-send a character. 
 
The same problem occurs on several different hardware platforms, with
two different Linux kernels (2.2 and 2.4),
and with different usb-modems.


Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.use mgetty to answer incoming calls on a usb modem
2.use another machine to dail in (we used cu program to do that)
3. login

	

Actual Results:  All output from the remote site goes into one line 


Additional info:
Comment 1 Bugzilla owner 2004-09-30 11:39:20 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.